diff --git a/src/V3DfgSynthesize.cpp b/src/V3DfgSynthesize.cpp
index e36a4e91e30..16d3badadd9 100644
--- a/src/V3DfgSynthesize.cpp
+++ b/src/V3DfgSynthesize.cpp
@@ -1150,67 +1157,34 @@ class AstToDfgSynthesize final {
         return true;
     }
 
-    // Gieven the drivers of a variable after converting a single statement
-    // 'newp', add drivers from 'oldp' that were not reassigned be drivers
-    // in newp. This computes the total result of all previous assignments.
-    bool incorporatePreviousValue(Variable* varp, const DfgVertexVar* newp, DfgVertexVar* oldp) {
-        UASSERT_OBJ(newp->srcp(), varp, "Assigned variable has no driver");
-
-        // Easy if there is no old value...
-        if (!oldp) return true;
-
-        // New driver was not yet coalesced, so should always be a splice
-        DfgVertexSplice* const nSplicep = newp->srcp()->as<DfgVertexSplice>();
-
-        // If the old value is the real variable we just computed the new value for,
-        // then it is the circular feedback into the synthesized block, add it as default driver.
-        if (oldp->nodep() == varp) {
-            if (!nSplicep->wholep()) nSplicep->defaultp(oldp);
-            return true;
-        }
-
-        UASSERT_OBJ(oldp->srcp(), varp, "Previously assigned variable has no driver");
-
-        // Can't do arrays yet
-        if (VN_IS(newp->dtypep(), UnpackArrayDType)) {
-            ++m_ctx.m_synt.nonSynArray;
-            return false;
-        }
-
-        // Gather drivers of 'newp' - they are in incresing range order with no overlaps
-        std::vector<Driver> nDrivers;
-        DfgVertex* nDefaultp = nullptr;
-        std::tie(nDrivers, nDefaultp) = gatherDrivers(newp->srcp()->as<DfgVertexSplice>());
-        UASSERT_OBJ(!nDrivers.empty(), varp, "Should have a proper driver");
-        UASSERT_OBJ(!nDefaultp, varp, "Should not have a default after conversion");
-
+    std::vector<Driver> computePropagatedDrivers(const std::vector<Driver>& newDrivers,
+                                                 DfgVertexVar* oldp) {
         // Gather drivers of 'oldp' - they are in incresing range order with no overlaps
-        std::vector<Driver> oDrivers;
-        DfgVertex* oDefaultp = nullptr;
-        std::tie(oDrivers, oDefaultp) = gatherDrivers(oldp->srcp()->as<DfgVertexSplice>());
-        UASSERT_OBJ(!oDrivers.empty(), varp, "Should have a proper driver");
+        std::vector<Driver> oldDrivers = gatherDrivers(oldp->srcp()->as<DfgVertexSplice>());
+        UASSERT_OBJ(!oldDrivers.empty(), oldp, "Should have a proper driver");
 
         // Additional drivers of 'newp' propagated from 'oldp'
-        std::vector<Driver> pDrivers;
+        std::vector<Driver> propagatedDrivers;
 
         // Add bits between 'msb' and 'lsb' from 'oldp' to 'pDrivers'
-        const auto addToPDriver = [&](FileLine* const flp, uint32_t msb, uint32_t lsb) {
-            UASSERT_OBJ(pDrivers.empty() || lsb > pDrivers.back().m_hi, flp, "Non ascending");
-            DfgSel* const selp = make<DfgSel>(flp, DfgGraph::dtypePacked(msb - lsb + 1));
+        const auto addOldDriver = [&](FileLine* const flp, uint32_t msb, uint32_t lsb) {
+            UASSERT_OBJ(propagatedDrivers.empty() || lsb > propagatedDrivers.back().m_hi, flp,
+                        "Drivers should be in ascending order");
+            DfgSel* const selp = make<DfgSel>(flp, V3Dfg::dtypePacked(msb - lsb + 1));
             selp->lsb(lsb);
             selp->fromp(oldp);
-            pDrivers.emplace_back(flp, lsb, selp);
+            propagatedDrivers.emplace_back(selp, lsb, flp);
         };
 
         // Incorporate old drivers
-        for (const Driver& oDriver : oDrivers) {
+        for (const Driver& oDriver : oldDrivers) {
             FileLine* const flp = oDriver.m_flp;
             // Range to consider inserting, we will adjust oldLo as we process drivers
             uint32_t oldLo = oDriver.m_lo;
             const uint32_t oldHi = oDriver.m_hi;
 
             // Loop for now, can move to bisection search if this is a problem, shouldn't be ...
-            for (const Driver& nDriver : nDrivers) {
+            for (const Driver& nDriver : newDrivers) {
                 UASSERT_OBJ(oldHi >= oldLo, flp, "Should have stopped iteration");
                 // If new driver is entirely below old driver, move on to
                 if (nDriver.m_hi < oldLo) continue;
@@ -1220,7 +1194,7 @@ class AstToDfgSynthesize final {
                 // There is an overlap between 'oDriver' and 'nDriver'.
                 // Insert the low bits and adjust the insertion range.
                 // The rest will take care of itself on subsequent iterations.
-                if (oldLo < nDriver.m_lo) addToPDriver(flp, nDriver.m_lo - 1, oldLo);
+                if (oldLo < nDriver.m_lo) addOldDriver(flp, nDriver.m_lo - 1, oldLo);
                 oldLo = nDriver.m_hi + 1;
 
                 // Stop if no more bits remaining in the old driver
@@ -1228,13 +1202,50 @@ class AstToDfgSynthesize final {
             }
 
             // Insert remaining bits if any
-            if (oldHi >= oldLo) addToPDriver(flp, oldHi, oldLo);
+            if (oldHi >= oldLo) addOldDriver(flp, oldHi, oldLo);
         }
 
+        return propagatedDrivers;
+    }
+
+    // Given the drivers of a variable after converting a single statement
+    // 'newp', add drivers from 'oldp' that were not reassigned be drivers
+    // in newp. This computes the total result of all previous assignments.
+    bool incorporatePreviousValue(Variable* varp, DfgVertexVar* newp, DfgVertexVar* oldp) {
+        UASSERT_OBJ(newp->srcp(), varp, "Assigned variable has no driver");
+
+        // Easy if there is no old value...
+        if (!oldp) return true;
+
+        // New driver was not yet coalesced, so should always be a splice
+        DfgVertexSplice* const nSplicep = newp->srcp()->as<DfgVertexSplice>();
+
+        // If the old value is the real variable we just computed the new value for,
+        // then it is the circular feedback into the synthesized block, add it as default driver.
+        if (oldp->nodep() == varp) {
+            if (!nSplicep->wholep()) newp->defaultp(oldp);
+            return true;
+        }
+
+        UASSERT_OBJ(oldp->srcp(), varp, "Previously assigned variable has no driver");
+
+        // Can't do arrays yet
+        if (VN_IS(newp->dtypep(), UnpackArrayDType)) {
+            ++m_ctx.m_synt.nonSynArray;
+            return false;
+        }
+
+        // Gather drivers of 'newp' - they are in incresing range order with no overlaps
+        UASSERT_OBJ(!newp->defaultp(), newp, "Converted value should not have default");
+        std::vector<Driver> nDrivers = gatherDrivers(newp->srcp()->as<DfgVertexSplice>());
+        UASSERT_OBJ(!nDrivers.empty(), newp, "Should have a proper driver");
+
+        // Additional drivers of 'newp' propagated from 'oldp'
+        std::vector<Driver> pDrivers = computePropagatedDrivers(nDrivers, oldp);
+
         if (!pDrivers.empty()) {
-            // Need to merge propagated sources, so unlink and reset the splice
-            nSplicep->forEachSourceEdge([](DfgEdge& edge, size_t) { edge.unlinkSource(); });
-            nSplicep->resetSources();
+            // Need to merge propagated sources, so reset the splice
+            nSplicep->resetDrivers();
             // Merge drivers - they are both sorted and non-overlapping
             std::vector<Driver> drivers;
             drivers.reserve(nDrivers.size() + pDrivers.size());
@@ -1243,11 +1254,11 @@ class AstToDfgSynthesize final {
             // Coalesce adjacent ranges
             coalesceDrivers(drivers);
             // Reinsert drivers in order
-            for (const Driver& d : drivers) nSplicep->addDriver(d.m_flp, d.m_lo, d.m_vtxp);
+            for (const Driver& d : drivers) nSplicep->addDriver(d.m_vtxp, d.m_lo, d.m_flp);
         }
 
         // If the old had a default, add to the new one too, unless redundant
-        if (oDefaultp && !nSplicep->wholep()) nSplicep->defaultp(oDefaultp);
+        if (oldp->defaultp() && !nSplicep->wholep()) newp->defaultp(oldp->defaultp());
 
         // Done
         return true;
@@ -1287,18 +1298,19 @@ class AstToDfgSynthesize final {
                     // The new, potentially partially assigned value
                     DfgVertexVar* const newp = pair.second;
                     // Normalize drivers within this statement, bail if multidriven
-                    std::vector<Driver> drivers;
-                    DfgVertex* dfltp = nullptr;
-                    std::tie(drivers, dfltp) = gatherDrivers(newp->srcp()->as<DfgVertexSplice>());
-                    UASSERT_OBJ(!dfltp, varp, "Conversion should not add default driver");
+                    DfgVertexSplice* const srcp = newp->srcp()->as<DfgVertexSplice>();
+                    std::vector<Driver> drivers = gatherDrivers(srcp);
                     const bool single = drivers.size() == 1;
                     if (!normalizeDrivers(*newp, drivers)) {
                         getAstVar(varp)->setDfgMultidriven();
                         ++m_ctx.m_synt.nonSynMultidrive;
                         return false;
                     }
-                    // If there were more than one driver (often not), replace in case coalesced
-                    if (!single) newp->srcp(makeSplice(*newp, drivers));
+                    // If there were more than one driver (often not), re-add in case coalesced
+                    if (!single) {
+                        srcp->resetDrivers();
+                        for (const Driver& d : drivers) srcp->addDriver(d.m_vtxp, d.m_lo, d.m_flp);
+                    }
                     // The old value, if any
                     DfgVertexVar* const oldp = varp->user2u().template to<DfgVertexVar*>();
                     // Inncorporate old value into the new value
@@ -1316,23 +1328,20 @@ class AstToDfgSynthesize final {
             if (AstIf* const ifp = VN_CAST(stmtp, If)) {
                 UASSERT_OBJ(ifp == stmtps.back(), ifp, "Branch should be last statement");
                 // Convert condition, give up if failed
-                DfgVertex* const condp = m_converter.convert(*m_logicp, ifp->condp());
+                DfgVertex* condp = m_converter.convert(*m_logicp, ifp->condp());
                 if (!condp) {
                     ++m_ctx.m_synt.nonSynConv;
                     return false;
                 }
-                //
-                if (condp->width() == 1) {
-                    // Single bit condition can be use directly
-                    condpr = condp;
-                } else {
-                    // Multi bit condition: use 'condp != 0'
+                // Single bit condition can be use directly, otherwise: use 'condp != 0'
+                if (condp->width() != 1) {
                     FileLine* const flp = condp->fileline();
-                    DfgNeq* const neqp = make<DfgNeq>(flp, DfgGraph::dtypePacked(1));
+                    DfgNeq* const neqp = make<DfgNeq>(flp, V3Dfg::dtypePacked(1));
                     neqp->lhsp(make<DfgConst>(flp, condp->width(), 0U));
                     neqp->rhsp(condp);
-                    condpr = neqp;
+                    condp = neqp;
                 }
+                condpr = condp;
                 continue;
             }
 
@@ -1367,30 +1376,50 @@ class AstToDfgSynthesize final {
             return resp;
         }();
 
+        size_t n = m_nPathPred++;  // Sequence number for temporaries
+        AstNodeDType* const dtypep = predp->dtypep();
+
+        const auto mkTmp = [&](FileLine* flp, const char* name, DfgVertex* srcp) {
+            std::string prefix;
+            prefix += "_BB";
+            prefix += std::to_string(bb.id());
+            prefix += "_";
+            prefix += name;
+            DfgVertexVar* const tmpp = m_converter.createTmp(*m_logicp, flp, dtypep, prefix, n);
+            tmpp->srcp(srcp);
+            return tmpp;
+        };
+
+        // Assign it to a variable in case it's used multiple times
+        DfgVertexVar* const pInp = mkTmp(predp->fileline(), "PathIn", predp);
+
         // For uncondional branches, the successor predicate edge is the same
         if (!bb.isBranch()) {
-            m_edgeToPredicatep[bb.takenEdgep()] = predp;
+            m_edgeToPredicatep[bb.takenEdgep()] = mkTmp(pInp->fileline(), "Goto", pInp);
             return;
         }
 
         // For branches, we need to factor in the branch condition
         DfgVertex* const condp = m_bbToCondp[bb];
         FileLine* const flp = condp->fileline();
-        AstNodeDType* const dtypep = condp->dtypep();  // Single bit
 
         // Predicate for taken branch: 'predp & condp'
-        DfgAnd* const takenPredp = make<DfgAnd>(flp, dtypep);
-        takenPredp->lhsp(predp);
-        takenPredp->rhsp(condp);
-        m_edgeToPredicatep[bb.takenEdgep()] = takenPredp;
+        {
+            DfgAnd* const takenPredp = make<DfgAnd>(flp, dtypep);
+            takenPredp->lhsp(pInp);
+            takenPredp->rhsp(condp);
+            m_edgeToPredicatep[bb.takenEdgep()] = mkTmp(flp, "Taken", takenPredp);
+        }
 
         // Predicate for untaken branch: 'predp & ~condp'
-        DfgAnd* const untknPredp = make<DfgAnd>(flp, dtypep);
-        untknPredp->lhsp(predp);
-        DfgNot* const notp = make<DfgNot>(flp, dtypep);
-        notp->srcp(condp);
-        untknPredp->rhsp(notp);
-        m_edgeToPredicatep[bb.untknEdgep()] = untknPredp;
+        {
+            DfgAnd* const untknPredp = make<DfgAnd>(flp, dtypep);
+            untknPredp->lhsp(pInp);
+            DfgNot* const notp = make<DfgNot>(flp, dtypep);
+            notp->srcp(condp);
+            untknPredp->rhsp(notp);
+            m_edgeToPredicatep[bb.untknEdgep()] = mkTmp(flp, "Untkn", untknPredp);
+        }
     }
 
     // Add the synthesized values as drivers to the output variables of the current DfgLogic
@@ -1400,7 +1429,7 @@ class AstToDfgSynthesize final {
         // These LHS forms can happen after some earlier tranforms. We
         // should just run V3Const on them earlier, but we will do belt and
         // braces and check here too. We can't touch any output variables if so.
-        const bool missing = m_logicp->findSink<DfgVertex>([&](const DfgVertex& sink) -> bool {
+        const bool missing = m_logicp->foreachSink([&](const DfgVertex& sink) {
             const DfgUnresolved* const unresolvedp = sink.as<DfgUnresolved>();
             AstNode* const tgtp = unresolvedp->singleSink()->as<DfgVertexVar>()->nodep();
             // cppcheck-suppress constVariablePointer
@@ -1413,16 +1442,41 @@ class AstToDfgSynthesize final {
         }
 
         // Add sinks to read the computed values for the target variables
-        m_logicp->forEachSink([&](DfgVertex& sink) {
+        bool hasUsedArrayOutput = false;
+        m_logicp->foreachSink([&](DfgVertex& sink) {
             DfgUnresolved* const unresolvedp = sink.as<DfgUnresolved>();
             AstNode* const tgtp = unresolvedp->singleSink()->as<DfgVertexVar>()->nodep();
             // cppcheck-suppress constVariablePointer
             Variable* const varp = reinterpret_cast<Variable*>(tgtp);
             DfgVertexVar* const resp = oSymTab.at(varp);
             UASSERT_OBJ(resp->srcp(), resp, "Undriven result");
-            unresolvedp->addDriver(resp->srcp()->as<DfgVertexSplice>());
+
+            // If the output is not used further in the synthesized logic itself,
+            // then resp will be deleted before we return, so we can just use
+            // its splice directly without ending up with a multi-use operation.
+            if (!resp->hasSinks()) {
+                unresolvedp->addDriver(resp->srcp()->as<DfgVertexSplice>());
+                return false;
+            }
+
+            // TODO: computePropagatedDrivers cannot handle arrays, should
+            // never happen with AssignW
+            if (!resp->isPacked()) {
+                if (!hasUsedArrayOutput) ++m_ctx.m_synt.nonSynArray;
+                hasUsedArrayOutput = true;
+                return false;
+            }
+
+            // We need to add a new splice to avoid multi-use of the original splice
+            DfgSplicePacked* const splicep
+                = new DfgSplicePacked{m_dfg, resp->fileline(), resp->dtypep()};
+            // Drivers are the same
+            const std::vector<Driver> drivers = computePropagatedDrivers({}, resp);
+            for (const Driver& d : drivers) splicep->addDriver(d.m_vtxp, d.m_lo, d.m_flp);
+            unresolvedp->addDriver(splicep);
+            return false;
         });
-        return true;
+        return !hasUsedArrayOutput;
     }
 
     // Synthesize the given AstAssignW. Returns true on success.
@@ -1481,13 +1535,13 @@ class AstToDfgSynthesize final {
             }
             // Initialize maps needed for non-trivial CFGs
             m_domTree = CfgDominatorTree{cfg};
-            m_edgeToPredicatep = cfg.makeEdgeMap<DfgVertex*>();
+            m_edgeToPredicatep = cfg.makeEdgeMap<DfgVertexVar*>();
         }
 
         // Initialize CfgMaps
         m_bbToISymTab = cfg.makeBlockMap<SymTab>();
         m_bbToOSymTab = cfg.makeBlockMap<SymTab>();
-        m_bbToCondp = cfg.makeBlockMap<DfgVertex*>();
+        m_bbToCondp = cfg.makeBlockMap<DfgVertexVar*>();
 
         // Synthesize all blocks
         for (const V3GraphVertex& vtx : cfg.vertices()) {
@@ -1495,12 +1549,20 @@ class AstToDfgSynthesize final {
             // Prepare the input symbol table of this block (enter, or join predecessor blocks)
             if (!createInputSymbolTable(bb)) return false;
             // Synthesize this block
-            if (!synthesizeBasicBlock(m_bbToOSymTab[bb],  //
-                                      m_bbToCondp[bb],  //
-                                      bb.stmtps(),  //
-                                      m_bbToISymTab[bb])) {
+            DfgVertex* condp = nullptr;
+            if (!synthesizeBasicBlock(m_bbToOSymTab[bb], condp, bb.stmtps(), m_bbToISymTab[bb])) {
                 return false;
             }
+            // Create a temporary for the branch condition as it might be used multiple times
+            if (condp) {
+                FileLine* const flp = condp->fileline();
+                AstNodeDType* const dtypep = condp->dtypep();
+                const std::string prefix = "_BB" + std::to_string(bb.id()) + "_Cond";
+                const size_t n = m_nBranchCond++;
+                DfgVertexVar* const vp = m_converter.createTmp(*m_logicp, flp, dtypep, prefix, n);
+                vp->srcp(condp);
+                m_bbToCondp[bb] = vp;
+            }
             // Set the path predicates on the successor edges
             assignPathPredicates(bb);
         }
@@ -1539,9 +1601,10 @@ class AstToDfgSynthesize final {
 
         // Gather all logic driving this unresolved driver
         std::vector<DfgLogic*> logicps;
-        logicps.reserve(vtxp->arity());
-        vtxp->forEachSource([&](DfgVertex& src) {
+        logicps.reserve(vtxp->nInputs());
+        vtxp->foreachSource([&](DfgVertex& src) {
             if (DfgLogic* const p = src.cast<DfgLogic>()) logicps.emplace_back(p);
+            return false;
         });
 
         // Delete the unresolved driver
@@ -1592,8 +1655,8 @@ class AstToDfgSynthesize final {
             if (!unresolvedp) break;  // Stop when reached the synthesized temporaries
 
             // Check if any driver have failed to synthesize
-            const bool failed = unresolvedp->findSourceEdge([&](const DfgEdge& e, size_t) -> bool {
-                DfgLogic* const driverp = e.sourcep()->cast<DfgLogic>();
+            const bool failed = unresolvedp->foreachSource([&](DfgVertex& src) {
+                DfgLogic* const driverp = src.cast<DfgLogic>();
                 return driverp && driverp->synth().empty();
             });
             // Revert all logic involved
@@ -1610,14 +1673,16 @@ class AstToDfgSynthesize final {
         // Compute resolved drivers of all variablees
         for (DfgVertexVar& var : m_dfg.varVertices()) {
             if (!var.srcp()) continue;
-            const DfgUnresolved* const unresolvedp = var.srcp()->cast<DfgUnresolved>();
+            DfgUnresolved* const unresolvedp = var.srcp()->cast<DfgUnresolved>();
             if (!unresolvedp) break;  // Stop when reached the synthesized temporaries
 
             // Resolve the synthesized drivers
             DfgVertexSplice* const resolvedp = [&]() -> DfgVertexSplice* {
                 // All synthesized drivers were normalized already,
                 // so if there is only one, it can be used directly
-                if (const auto p = unresolvedp->singleSource()) return p->as<DfgVertexSplice>();
+                if (unresolvedp->nInputs() == 1) {
+                    return unresolvedp->inputp(0)->as<DfgVertexSplice>();
+                }
                 // Otherwise gather the synthesized drivers
                 std::vector<Driver> drivers = gatherDriversUnresolved(unresolvedp);
                 // Normalize them, make resolved driver if all good
@@ -1673,8 +1738,9 @@ class AstToDfgSynthesize final {
             } else {
                 // Not synthesized. Logic stays in Ast. Mark source  variables
                 //as read in module. Outputs already marked by revertTransivelyAndRemove.
-                logicp->forEachSource([](DfgVertex& src) {  //
+                logicp->foreachSource([](DfgVertex& src) {  //
                     src.as<DfgVertexVar>()->setHasModRdRefs();
+                    return false;
                 });
             }
 
@@ -1698,7 +1764,7 @@ class AstToDfgSynthesize final {
             }
 
             // It should alway have drivers
-            UASSERT_OBJ(splicep->arity(), splicep, "Splice with no drivers");
+            UASSERT_OBJ(splicep->nInputs(), splicep, "Splice with no drivers");
 
             // If redundant, remove it
             if (DfgVertex* const wholep = splicep->wholep()) {
@@ -1715,6 +1781,18 @@ class AstToDfgSynthesize final {
         UINFO(5, "Step 6: Remove all unused vertices");
         V3DfgPasses::removeUnused(m_dfg);
         debugDump("synth-rmunused");
+
+        // No operation vertex should have multiple sinks. Cyclic decomoposition
+        // depends on this and it can easily be ensured by using temporaries.
+        // Also, all sources should be connected at this point
+        if (v3Global.opt.debugCheck()) {
+            for (DfgVertex& vtx : m_dfg.opVertices()) {
+                UASSERT_OBJ(!vtx.hasMultipleSinks(), &vtx, "Operation has multiple sinks");
+                for (size_t i = 0; i < vtx.nInputs(); ++i) {
+                    UASSERT_OBJ(vtx.inputp(i), &vtx, "Unconnected source operand");
+                }
+            }
+        }
     }
 
     // CONSTRUCTOR
@@ -1763,13 +1841,13 @@ void V3DfgPasses::synthesize(DfgGraph& dfg, V3DfgContext& ctx) {
             const DfgUnresolved* const unresolvedp = var.srcp()->as<DfgUnresolved>();
 
             // Inspect drivers to figure out if we should synthesize them
-            const bool doIt = unresolvedp->findSourceEdge([](const DfgEdge& edge, size_t) -> bool {
-                const DfgLogic* const logicp = edge.sourcep()->as<DfgLogic>();
-                // Synthesize continuous assignments (this is the earlier behaviour)
-                if (VN_IS(logicp->nodep(), AssignW)) return true;
+            const bool doIt = unresolvedp->foreachSource([&](const DfgVertex& src) {
+                const DfgLogic* const logicp = src.as<DfgLogic>();
+                // Synthesize continuous assignments (this is the earlier behaviour).
                 // Synthesize always blocks with no more than 4 basic blocks and 4 edges
                 // These are usually simple branches (if (rst) ... else ...), or close to it
-                return logicp->cfg().nBlocks() <= 4 && logicp->cfg().nEdges() <= 4;
+                return VN_IS(logicp->nodep(), AssignW)  //
+                       || (logicp->cfg().nBlocks() <= 4 && logicp->cfg().nEdges() <= 4);
             });
             if (doIt) varps.emplace_back(&var);
         }
@@ -1777,9 +1855,10 @@ void V3DfgPasses::synthesize(DfgGraph& dfg, V3DfgContext& ctx) {
         // Gather all drivers of the selected variables
         const VNUser2InUse user2InUse;  // AstNode (logic) -> bool: already collected
         for (const DfgVertexVar* const varp : varps) {
-            varp->srcp()->as<DfgUnresolved>()->forEachSource([&](DfgVertex& source) {
+            varp->srcp()->as<DfgUnresolved>()->foreachSource([&](DfgVertex& source) {
                 DfgLogic* const logicp = source.as<DfgLogic>();
                 if (!logicp->nodep()->user2Inc()) logicps.emplace_back(logicp);
+                return false;
             });
         }
     }
diff --git a/src/astgen b/src/astgen
index d36d6fd5921..57d17bb8dff 100755
--- a/src/astgen
+++ b/src/astgen
@@ -678,6 +678,10 @@ def check_types(sortedTypes, prefix, abstractPrefix):
                 sys.exit("%Error: Non-final {b} subclasses must be named {b}*: {p}{n}".format(
                     b=baseClass, p=prefix, n=node.name))
 
+    # Skip ordering check for Dfg
+    if prefix == "Dfg":
+        return
+
     # Check ordering of node definitions
     hasOrderingError = False
 
@@ -1169,6 +1173,9 @@ def write_dfg_macros(filename):
                                 "    ").format(**fmt).replace("\n", " \\\n"))
 
         for node in DfgVertexList:
+            if node.isRoot:
+                continue
+
             fh.write("#define ASTGEN_MEMBERS_Dfg{t} \\\n".format(t=node.name))
 
             if node.isLeaf:
@@ -1183,22 +1190,24 @@ def write_dfg_macros(filename):
             for n in range(1, node.arity + 1):
                 name, _, _, _ = node.getOp(n)
                 emitBlock('''\
-                DfgVertex* {name}() const {{ return source<{n}>(); }}
-                void {name}(DfgVertex* vtxp) {{ relinkSource<{n}>(vtxp); }}
+                DfgVertex* {name}() const {{ return inputp({n}); }}
+                void {name}(DfgVertex* vtxp) {{ inputp({n}, vtxp); }}
                 ''',
                           name=name,
                           n=n - 1)
 
-            operandNames = tuple(node.getOp(n)[0] for n in range(1, node.arity + 1))
-            if operandNames:
-                emitBlock('''\
-                          const std::string srcName(size_t idx) const override {{
-                              static const char* names[{a}] = {{ {ns} }};
-                              return names[idx];
-                          }}
-                          ''',
-                          a=node.arity,
-                          ns=", ".join(map(lambda _: '"' + _ + '"', operandNames)))
+            if node.isLeaf and node.arity > 1:
+                operandNames = tuple(node.getOp(n)[0] for n in range(1, node.arity + 1))
+                if operandNames:
+                    emitBlock('''\
+                              std::string srcName(size_t idx) const override final {{
+                                  static const char* names[{a}] = {{ {ns} }};
+                                  return names[idx];
+                              }}
+                              ''',
+                              a=node.arity,
+                              ns=", ".join(map(lambda _: '"' + _ + '"', operandNames)))
+
             fh.write("    static_assert(true, \"\")\n")  # Swallowing the semicolon
 
 
@@ -1215,6 +1224,8 @@ def write_dfg_auto_classes(filename):
 
             emitBlock('''\
                       class Dfg{t} final : public Dfg{s} {{
+                          bool selfEquals(const DfgVertex&) const final {{ return true; }}
+                          V3Hash selfHash() const final {{ return V3Hash{{}}; }}
                       public:
                           Dfg{t}(DfgGraph& dfg, FileLine* flp, AstNodeDType* dtypep)
                               : Dfg{s}{{dfg, dfgType(), flp, dtypep}} {{}}
@@ -1275,12 +1286,12 @@ def write_dfg_ast_to_dfg(filename):
             fh.write("        m_foundUnhandled = true;\n")
             fh.write("        ++m_ctx.m_conv.nonRepNode;\n")
             fh.write("        return;\n")
-            fh.write("    }\n\n")
-            fh.write("    m_logicp->synth().emplace_back(vtxp);")
+            fh.write("    }\n")
+            fh.write("    m_logicp->synth().emplace_back(vtxp);\n\n")
             for i in range(node.arity):
                 fh.write(
-                    "    vtxp->relinkSource<{i}>(nodep->op{j}p()->user2u().to<DfgVertex*>());\n".
-                    format(i=i, j=i + 1))
+                    "    vtxp->inputp({i}, nodep->op{j}p()->user2u().to<DfgVertex*>());\n".format(
+                        i=i, j=i + 1))
             fh.write("\n")
             fh.write("    nodep->user2p(vtxp);\n")
             fh.write("}\n")
@@ -1296,7 +1307,7 @@ def write_dfg_dfg_to_ast(filename):
             fh.write("void visit(Dfg{t}* vtxp) override {{\n".format(t=node.name))
             for i in range(node.arity):
                 fh.write(
-                    "    AstNodeExpr* const op{j}p = convertDfgVertexToAstNodeExpr(vtxp->source<{i}>());\n"
+                    "    AstNodeExpr* const op{j}p = convertDfgVertexToAstNodeExpr(vtxp->inputp({i}));\n"
                     .format(i=i, j=i + 1))
             fh.write("    m_resultp = makeNode<Ast{t}>(vtxp".format(t=node.name))
             for i in range(node.arity):
@@ -1355,14 +1366,6 @@ check_types(AstNodeList, "Ast", "Node")
 # Set up the root DfgVertex type and some other hand-written base types.
 # These are standalone so we don't need to parse the sources for this.
 DfgVertices["Vertex"] = Node("Vertex", None)
-DfgVertices["VertexUnary"] = Node("VertexUnary", DfgVertices["Vertex"])
-DfgVertices["Vertex"].addSubClass(DfgVertices["VertexUnary"])
-DfgVertices["VertexBinary"] = Node("VertexBinary", DfgVertices["Vertex"])
-DfgVertices["Vertex"].addSubClass(DfgVertices["VertexBinary"])
-DfgVertices["VertexTernary"] = Node("VertexTernary", DfgVertices["Vertex"])
-DfgVertices["Vertex"].addSubClass(DfgVertices["VertexTernary"])
-DfgVertices["VertexVariadic"] = Node("VertexVariadic", DfgVertices["Vertex"])
-DfgVertices["Vertex"].addSubClass(DfgVertices["VertexVariadic"])
 
 # AstNodeExpr that are not representable in Dfg
 DfgIgnored = (
@@ -1424,6 +1427,7 @@ DfgIgnored = (
     "ReplicateN",
     "SubstrN",
     "ToLowerN",
+    "ToStringN",
     "ToUpperN",
     # Effectful
     "PostAdd",
